import{s as ce,n as ve,o as we}from"../chunks/scheduler.7bc62968.js";import{S as be,i as xe,g as o,s as i,r as Z,A as Te,h as s,f as n,c as l,j as ge,u as Q,x as r,k as B,y as Ce,a,v as J,d as K,t as X,w as Y}from"../chunks/index.2f8492b0.js";import{H as ee}from"../chunks/Heading.14fb2476.js";function ye(te){let d,P,L,M,p,H,f,ne="In the preceding sections, we’ve delved into the fundamental concepts of multimodal models such as CLIP and its related counterparts. In this chapter, we will try to find out how you can use different types of multimodal models for your tasks.",I,u,ae="There are several approaches to how you can adapt multimodal models to your use case:",A,m,ie='<li><p><strong>Zero\\few-shot learning</strong>. Zero\\few-shot learning involves leveraging large pretrained models capable of solving problems not present in the training data. These approaches can be useful when there is little labeled data for a task (5-10 examples) or there is none at all. <a href="../Unit%2011%20%20-%20Zero%20Shot%20Computer%20Vision/1.mdx">Unit 11</a> will delve deeper into this topic.</p></li> <li><p><strong>Training the model from scratch</strong>. When pre-trained model weights are unavailable or the model’s dataset substantially differs from your own, this method becomes necessary. Here, we initialize model weights randomly (or via more sophisticated methods like <a href="https://arxiv.org/abs/1502.01852" rel="nofollow">He initialization</a>) and proceed with the usual training. However, this approach demands substantial amounts of training data.</p></li> <li><p><strong>Transfer learning</strong>. Transfer learning, unlike training from scratch, uses the weights of the pretrained model as initial weights.</p></li>',D,g,le="This chapter primarily focuses on the transfer learning aspect within multimodal models. It will recap what transfer learning entails, elucidate its advantages, and provide practical examples illustrating how you can apply transfer learning to your tasks!",j,c,q,v,oe="More formally, transfer learning is the set of machine learning techniques in which knowledge, representations or patterns that are obtained from solving one problem are reused to solve another, but similar problem.",z,w,se="In the context of deep learning, in transfer learning, when training a model for a particular task, we use the weights of another model as the initial weights. The pretrained model has typically been trained on a huge amount of data and has useful knowledge about the nature and relationships in that data. This knowledge is embedded in the weights of this model, and therefore if we use them as initial weights, we transfer the knowledge embedded in the pretrained model into the model we are training.",S,h,re='<img src="https://huggingface.co/datasets/hf-vision/course-assets/resolve/main/multimodal_trasnsfer_learning_images/transfer_learning_light.png" alt="Transfer Learning"/>',V,b,de="This approach has several advantages:",E,x,he="<li><p><strong>Resource Efficiency:</strong> Since the pretrained model was trained on a huge amount of data over a long period, transfer learning requires much less computing resources for model convergence.</p></li> <li><p><strong>Reducing the size of labeled data:</strong> For the same reason, less data is required to achieve decent quality on the test sample.</p></li> <li><p><strong>Knowledge Transfer:</strong> When fine-tuning to the new task, the model capitalizes on the pre-existing knowledge encoded within the pre-trained model’s weights. This integration of prior knowledge often leads to enhanced performance on the new task.</p></li>",N,T,pe="However, despite its advantages, transfer learning has some challenges that should also be taken into account:",O,C,fe="<li><p><strong>Domain Shift:</strong> Adapting knowledge from the source domain to the target domain can be challenging if the data distributions differ substantially.</p></li> <li><p><strong>Catastrophic forgetting:</strong> During fine-tuning process, the model adjusts its parameters to adapt to the new task, often causing it to lose the previously learned knowledge or representations related to the initial task.</p></li>",U,y,G,_,ue="We’ll explore practical applications of transfer learning across various tasks. Navigate to the Jupyter notebook relevant to your task of interest from the provided table.",R,k,me='<thead><tr><th>Task</th> <th>Description</th> <th>Model</th> <th>Notebook</th></tr></thead> <tbody><tr><td>Fine-tune CLIP</td> <td>Fine-tuning CLIP on a custom dataset</td> <td><a href="https://huggingface.co/openai/clip-vit-base-patch32" rel="nofollow">openai/clip-vit-base-patch32</a></td> <td><a href="https://" rel="nofollow">CLIP notebook</a></td></tr> <tr><td>VQA</td> <td>Answering a question in natural <br/> language based on an image</td> <td><a href="https://huggingface.co/dandelin/vilt-b32-finetuned-vqa" rel="nofollow">dandelin/vilt-b32-finetuned-vqa</a></td> <td><a href="https://" rel="nofollow">VQA notebook</a></td></tr> <tr><td>Image-to-Text</td> <td>Describing an image in natural language</td> <td><a href="https://huggingface.co/Salesforce/blip-image-captioning-large" rel="nofollow">Salesforce/blip-image-captioning-large</a></td> <td><a href="https://" rel="nofollow">Text 2 Image notebook</a></td></tr> <tr><td>Open-set object detection</td> <td>Detect objects by natural language input</td> <td><a href="https://github.com/IDEA-Research/GroundingDINO" rel="nofollow">Grounding DINO</a></td> <td><a href="https://" rel="nofollow">Grounding DINO notebook</a></td></tr> <tr><td>Assistant (GTP-4V like)</td> <td>Instruction tuning in the multimodal field</td> <td><a href="https://github.com/haotian-liu/LLaVA" rel="nofollow">LLaVA</a></td> <td><a href="https://" rel="nofollow">LLaVa notebook</a></td></tr></tbody>',F,$,W;return p=new ee({props:{title:"Transfer Learning of Multimodal Models",local:"transfer-learning-of-multimodal-models",headingTag:"h1"}}),c=new ee({props:{title:"Transfer learning",local:"transfer-learning",headingTag:"h2"}}),y=new ee({props:{title:"Transfer Learning Applications",local:"transfer-learning-applications",headingTag:"h2"}}),{c(){d=o("meta"),P=i(),L=o("p"),M=i(),Z(p.$$.fragment),H=i(),f=o("p"),f.textContent=ne,I=i(),u=o("p"),u.textContent=ae,A=i(),m=o("ol"),m.innerHTML=ie,D=i(),g=o("p"),g.textContent=le,j=i(),Z(c.$$.fragment),q=i(),v=o("p"),v.textContent=oe,z=i(),w=o("p"),w.textContent=se,S=i(),h=o("div"),h.innerHTML=re,V=i(),b=o("p"),b.textContent=de,E=i(),x=o("ul"),x.innerHTML=he,N=i(),T=o("p"),T.textContent=pe,O=i(),C=o("ul"),C.innerHTML=fe,U=i(),Z(y.$$.fragment),G=i(),_=o("p"),_.textContent=ue,R=i(),k=o("table"),k.innerHTML=me,F=i(),$=o("p"),this.h()},l(e){const t=Te("svelte-u9bgzb",document.head);d=s(t,"META",{name:!0,content:!0}),t.forEach(n),P=l(e),L=s(e,"P",{}),ge(L).forEach(n),M=l(e),Q(p.$$.fragment,e),H=l(e),f=s(e,"P",{"data-svelte-h":!0}),r(f)!=="svelte-1yup698"&&(f.textContent=ne),I=l(e),u=s(e,"P",{"data-svelte-h":!0}),r(u)!=="svelte-1eit1wn"&&(u.textContent=ae),A=l(e),m=s(e,"OL",{"data-svelte-h":!0}),r(m)!=="svelte-13j7x4n"&&(m.innerHTML=ie),D=l(e),g=s(e,"P",{"data-svelte-h":!0}),r(g)!=="svelte-a3wxu0"&&(g.textContent=le),j=l(e),Q(c.$$.fragment,e),q=l(e),v=s(e,"P",{"data-svelte-h":!0}),r(v)!=="svelte-rc824"&&(v.textContent=oe),z=l(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1w4zzss"&&(w.textContent=se),S=l(e),h=s(e,"DIV",{class:!0,"data-svelte-h":!0}),r(h)!=="svelte-12vvs06"&&(h.innerHTML=re),V=l(e),b=s(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-q9yp9o"&&(b.textContent=de),E=l(e),x=s(e,"UL",{"data-svelte-h":!0}),r(x)!=="svelte-8yj41r"&&(x.innerHTML=he),N=l(e),T=s(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-cga0tn"&&(T.textContent=pe),O=l(e),C=s(e,"UL",{"data-svelte-h":!0}),r(C)!=="svelte-3tbnho"&&(C.innerHTML=fe),U=l(e),Q(y.$$.fragment,e),G=l(e),_=s(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1at9fz0"&&(_.textContent=ue),R=l(e),k=s(e,"TABLE",{"data-svelte-h":!0}),r(k)!=="svelte-jagvj0"&&(k.innerHTML=me),F=l(e),$=s(e,"P",{}),ge($).forEach(n),this.h()},h(){B(d,"name","hf:doc:metadata"),B(d,"content",_e),B(h,"class","flex justify-center")},m(e,t){Ce(document.head,d),a(e,P,t),a(e,L,t),a(e,M,t),J(p,e,t),a(e,H,t),a(e,f,t),a(e,I,t),a(e,u,t),a(e,A,t),a(e,m,t),a(e,D,t),a(e,g,t),a(e,j,t),J(c,e,t),a(e,q,t),a(e,v,t),a(e,z,t),a(e,w,t),a(e,S,t),a(e,h,t),a(e,V,t),a(e,b,t),a(e,E,t),a(e,x,t),a(e,N,t),a(e,T,t),a(e,O,t),a(e,C,t),a(e,U,t),J(y,e,t),a(e,G,t),a(e,_,t),a(e,R,t),a(e,k,t),a(e,F,t),a(e,$,t),W=!0},p:ve,i(e){W||(K(p.$$.fragment,e),K(c.$$.fragment,e),K(y.$$.fragment,e),W=!0)},o(e){X(p.$$.fragment,e),X(c.$$.fragment,e),X(y.$$.fragment,e),W=!1},d(e){e&&(n(P),n(L),n(M),n(H),n(f),n(I),n(u),n(A),n(m),n(D),n(g),n(j),n(q),n(v),n(z),n(w),n(S),n(h),n(V),n(b),n(E),n(x),n(N),n(T),n(O),n(C),n(U),n(G),n(_),n(R),n(k),n(F),n($)),n(d),Y(p,e),Y(c,e),Y(y,e)}}}const _e='{"title":"Transfer Learning of Multimodal Models","local":"transfer-learning-of-multimodal-models","sections":[{"title":"Transfer learning","local":"transfer-learning","sections":[],"depth":2},{"title":"Transfer Learning Applications","local":"transfer-learning-applications","sections":[],"depth":2}],"depth":1}';function ke(te){return we(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Me extends be{constructor(d){super(),xe(this,d,ke,ye,ce,{})}}export{Me as component};
